using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;

namespace FormationGamePrototype.Helper
{
    public static class DebugText
    {
        static bool m_bVisible;
        static SpriteBatch m_ForegroundBatch;
        static SpriteFont m_DefaultFont;

        static List<String> m_StringList;

        static Color m_FontColor;

        static DebugText()
        {
            m_bVisible = true;
            m_FontColor = Color.Black;
        }

        static public bool Visible
        {
            get
            {
                return m_bVisible;
            }
            set
            {
                m_bVisible = value;
            }
        }

        static public Color FontColor
        {
            get
            {
                return m_FontColor;
            }
            set
            {
                m_FontColor = value;
            }
        }

        static public void LoadResources(GraphicsDeviceManager graphics, ContentManager content)
        {
            m_StringList = new List<string>(64);
            m_DefaultFont = content.Load<SpriteFont>("Content\\Fonts\\Default");
            m_ForegroundBatch = new SpriteBatch(graphics.GraphicsDevice);
        }

        static public void Output(String str, params object[] args)
        {
            m_StringList.Add(String.Format(str, args));
            //m_StringList.
                
                //= String.Format(str, args);
           // int foo = 4;
           // foo++;
        }

        static public void DrawStrings()
        {
            if (m_bVisible)
            {
                m_ForegroundBatch.Begin();

                Vector2 strPos = Vector2.Zero;

                foreach (String output in m_StringList)
                {
                    m_ForegroundBatch.DrawString(m_DefaultFont, output, strPos, m_FontColor, 0.0f, Vector2.Zero, 1.0f, SpriteEffects.None, 0.5f);
                    strPos.Y += m_DefaultFont.LineSpacing;
                }
                m_ForegroundBatch.End();
            }

            m_StringList.Clear();
        }
    }
}
